function Path(name) {
		
	if (!this.name)
		this.name = name;
	
	if (this.id == null) {
		var paths = Storage.getPaths();
		if (paths.length == 0) {
			this.id = 1;
		} else {
			var last = paths.pop();
			paths.push(last);
			this.id = last.id + 1;
		}/**/
	}
	
	if (!this.checkpoints) {
		this.checkpoints = new Array();
	}
	
	if (!this.lines) {
		this.lines = new Array();
	}
	
	if (!this.startLine) {
		this.startLine = null;
	}
	
	if (!this.sides) 
		this.sides = 0;
		
	if (!this.width)
		this.width = 600;
		
	if (!this.height)
		this.height = 600;
		
	return this;
	
}

	Path.prototype.id = null;
	Path.prototype.name = null; 
	
	Path.prototype.addLine = function(x1, y1, x2, y2) {
		
		this.lines.push(new Line(x1, y1, x2, y2));
		
	};
	
	Path.prototype.setStartLine = function(x1, y1, x2, y2) {
		
		var y = Math.round((y1+y2)/2);
		this.startLine = new Line(x1, y, x2, y);
		
	};
	
	Path.prototype.addCheckpoint = function(x, y) {
		
		this.checkpoints.push(new Checkpoint(new Point(x, y), this.checkpoints.length + 1));
		
	};
	
	Path.prototype.getWidth = function() {
		
		return this.width;
		
	};
	
	Path.prototype.setWidth = function(width) {
		
		this.width = parseInt(width);
		return this;
		
	};
	
	Path.prototype.getHeight = function() {
		
		return this.height;
		
	};
	
	Path.prototype.setHeight = function(height) {
		
		this.height = parseInt(height);
		return this;
		
	};
	
	Path.prototype.update = function() {
		
		if (!this.startLine) {
			console.log("Path must have start line.");
			return;
		}
		
		if (this.sides < 2) {
			console.log("Path has 2 sides.");
			return;
		}
		
		Storage.updatePath(this);
		
	};
