
	function Simulation(params) {

		this.states = new Array();
		this.createFromTextParams(params);
		
		return this;
		
	};
		
		Simulation.prototype.pathID = null;
		Simulation.prototype.states = null;
		
		Simulation.prototype.addState = function(state) {
						
			if (!(state instanceof SimulationState)) return false;
			
			this.states.push(state);
			
			return true;
			
		};
		
		Simulation.prototype.createFromTextParams = function(text) {
			
			var lines = text.split("\n");
			var numbers = null;
			var currentState = null;
			
			for (var i in lines) {
				numbers = lines[i].split(" ");
				if (numbers[0] == "PATH") {
					this.pathID = parseInt(numbers[1]);
				} else {
					currentState = new SimulationState(numbers[0], numbers[1], numbers[2]);
					this.addState(currentState);					
				}
			}
			
		};
		
		Simulation.prototype.getIterator = function() {
			
			return new this.Iterator(this);
			
		};
		
		Simulation.prototype.Iterator = function(simulation) {
			
			this.position = 0;
			this.simulation = simulation;
			
			return this;
			
		};
		
			Simulation.prototype.Iterator.prototype.simulation = null;
			Simulation.prototype.Iterator.prototype.position = 0;
		
			Simulation.prototype.Iterator.prototype.hasNext = function() {
			
				if ((this.position + 1) < this.simulation.states.length) return true;
				
				return false;
				
			};
			
			Simulation.prototype.Iterator.prototype.next = function() {
			
				return this.simulation.states[this.position++];
				
			};
		
	function SimulationState(x, y, angle) {
		
		this.x = parseInt(x);
		this.y = parseInt(y);
		this.angle = parseFloat(angle);
		
		return this;
		
	};
	
		SimulationState.prototype.getX = function() {
			
			return this.x;
			
		};
		
		SimulationState.prototype.getY = function() {
			
			return this.y;
			
		};
		
		SimulationState.prototype.getAngle = function() {
			
			return this.angle * 180 / Math.PI;
			
		};